/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <activemq/connector/openwire/commands/DataArrayResponse.h>
#include <activemq/exceptions/NullPointerException.h>

using namespace std;
using namespace activemq;
using namespace activemq::exceptions;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;

/*
 *
 *  Command and marshaling code for OpenWire format for DataArrayResponse
 *
 *
 *  NOTE!: This file is autogenerated - do not modify!
 *         if you need to make a change, please see the Java Classes in the
 *         activemq-core module
 *
 */
////////////////////////////////////////////////////////////////////////////////
DataArrayResponse::DataArrayResponse()
{
}

////////////////////////////////////////////////////////////////////////////////
DataArrayResponse::~DataArrayResponse()
{
    for( size_t idata = 0; idata < data.size(); ++idata ) {
        delete data[idata];
    }
}

////////////////////////////////////////////////////////////////////////////////
DataStructure* DataArrayResponse::cloneDataStructure() const {
    DataArrayResponse* dataArrayResponse = new DataArrayResponse();

    // Copy the data from the base class or classes
    dataArrayResponse->copyDataStructure( this );

    return dataArrayResponse;
}

////////////////////////////////////////////////////////////////////////////////
void DataArrayResponse::copyDataStructure( const DataStructure* src ) {

    // Copy the data of the base class or classes
    Response::copyDataStructure( src );

    const DataArrayResponse* srcPtr = dynamic_cast<const DataArrayResponse*>( src );

    if( srcPtr == NULL || src == NULL ) {
    
        throw exceptions::NullPointerException(
            __FILE__, __LINE__,
            "DataArrayResponse::copyDataStructure - src is NULL or invalid" );
    }
    for( size_t idata = 0; idata < srcPtr->getData().size(); ++idata ) {
        if( srcPtr->getData()[idata] != NULL ) {
            this->getData().push_back( 
                dynamic_cast<DataStructure*>( 
                    srcPtr->getData()[idata]->cloneDataStructure() ) );
        } else {
            this->getData().push_back( NULL );
        }
    }
}

////////////////////////////////////////////////////////////////////////////////
unsigned char DataArrayResponse::getDataStructureType() const {
    return DataArrayResponse::ID_DATAARRAYRESPONSE; 
}

////////////////////////////////////////////////////////////////////////////////
std::string DataArrayResponse::toString() const {

    ostringstream stream;

    stream << "Begin Class = DataArrayResponse" << std::endl;
    stream << " Value of DataArrayResponse::ID_DATAARRAYRESPONSE = 33" << std::endl; 
    for( size_t idata = 0; idata < this->getData().size(); ++idata ) {
        stream << " Value of Data[" << idata << "] is Below:" << std::endl;
        if( this->getData()[idata] != NULL ) {
            stream << this->getData()[idata]->toString() << std::endl;
        } else {
            stream << "   Object is NULL" << std::endl;
        }
    }
    stream << Response::toString();
    stream << "End Class = DataArrayResponse" << std::endl;

    return stream.str();
}

////////////////////////////////////////////////////////////////////////////////
bool DataArrayResponse::equals( const DataStructure* value ) const {
    const DataArrayResponse* valuePtr = dynamic_cast<const DataArrayResponse*>( value );

    if( valuePtr == NULL || value == NULL ) {
        return false;
    }
    for( size_t idata = 0; idata < this->getData().size(); ++idata ) {
        if( this->getData()[idata] != NULL ) {
            if( !this->getData()[idata]->equals( valuePtr->getData()[idata] ) ) {
                return false;
            }
        } else if( valuePtr->getData()[idata] != NULL ) {
            return false;
        }
    }
    if( !Response::equals( value ) ) {
        return false;
    }
    return true;
}

////////////////////////////////////////////////////////////////////////////////
const std::vector<DataStructure*>& DataArrayResponse::getData() const {
    return data;
}

////////////////////////////////////////////////////////////////////////////////
std::vector<DataStructure*>& DataArrayResponse::getData() {
    return data;
}

////////////////////////////////////////////////////////////////////////////////
void DataArrayResponse::setData(const std::vector<DataStructure*>& data ) {
    this->data = data;
}

